import board
import time
import digitalio
import pwmio
import neopixel
from audiomp3 import MP3Decoder
from adafruit_apds9960.apds9960 import APDS9960
from adafruit_motor import servo
from audiopwmio import PWMAudioOut as AudioOut
from audiocore import WaveFile
from adafruit_led_animation.color import (
    AMBER, #(255, 100, 0)
    AQUA, # (50, 255, 255)
    BLACK, #OFF (0, 0, 0)
    BLUE, # (0, 0, 255)
    CYAN, # (0, 255, 255)
    GOLD, # (255, 222, 30)
    GREEN, # (0, 255, 0)
    JADE, # (0, 255, 40)
    MAGENTA, #(255, 0, 20)
    OLD_LACE, # (253, 245, 230)
    ORANGE, # (255, 40, 0)
    PINK, # (242, 90, 255)
    PURPLE, # (180, 0, 255)
    RED, # (255, 0, 0)
    TEAL, # (0, 255, 120)
    WHITE, # (255, 255, 255)
    YELLOW, # (255, 150, 0)
    RAINBOW # a list of colors to cycle through
    # RAINBOW is RED, ORANGE, YELLOW, GREEN, BLUE, and PURPLE ((255, 0, 0), (255, 40, 0), (255, 150, 0), (0, 255, 0), (0, 0, 255), (180, 0, 255))
)
colors = [AMBER, AQUA, GOLD, PINK, ORANGE, RED, TEAL]


pwm = pwmio.PWMOut(board.A2, frequency=50)
pwm2 = pwmio.PWMOut(board.A3, frequency=50)
servo_1 = servo.Servo(pwm, max_pulse=2500)
servo_1 = servo.Servo(pwm)
servo_2 = servo.Servo(pwm2, max_pulse=2500)
servo_2 = servo.Servo(pwm2)

strip_pin= board.A1
strip_num_of_lights = 30
strip = neopixel.NeoPixel(strip_pin, strip_num_of_lights, brightness = 0.5, auto_write = True )
pixels_pin = board.NEOPIXEL
pixels_num_of_lights = 10
pixels = neopixel.NeoPixel(pixels_pin,pixels_num_of_lights)

speaker = digitalio.DigitalInOut(board.SPEAKER_ENABLE)
speaker.direction = digitalio.Direction.OUTPUT
speaker.value = True
audio = AudioOut(board.SPEAKER)

i2c = board.I2C()
multi_sensor = APDS9960(i2c)

multi_sensor.enable_proximity = True

path = "sounds/"
filename= "musicbox.mp3"
mp3_file=open(path + filename, "rb")
decoder = MP3Decoder(mp3_file)

def spin():
    color_num = 0
    for angle in range (0, 180, 10):
        servo_1.angle = angle
        if angle == 180:
            servo_1.angle = 180
            time.sleep(0.2)
        strip.fill(colors[color_num])
        time.sleep(0.5)
        color_num = color_num+1
        if color_num == len(colors):
            color_num = 0
        if angle == 0:
            strip.fill(BLACK)
    for angles in range (0,180,10):
        servo_2.angle = angles
        if angles == 180:
            servo_2.angle = 180
            time.sleep(0.2)
        strip.fill(colors[color_num])
        time.sleep(0.5)
        color_num = color_num+1
        if color_num == len(colors):
            color_num = 0
        if angle == 0:
            strip.fill(BLACK)
    for angless in range (180, -1, -10):
        servo_1.angle = angless
        time.sleep(0.2)
        servo_2.angle = angless
        if angless == 0:
            servo_1.angless = 0
            time.sleep(0.2)
            servo_2.angless = 0
            time.sleep(0.2)



def play_mp3(filename):
    decoder.file = open(path + filename, "rb")
    audio.play(decoder)
    while audio.playing:
        spin()


while True:
    reading = multi_sensor.proximity
    print ((reading,))
    time.sleep(0.02)
    if reading <= 6: #what reading i should do
        play_mp3(filename)
        print ("hello")
    if reading > 9:
        servo_1.angle = 0
        strip.fill(BLACK)
